/*
 * Purpose: AddressManager application
 * Author:  Frank Bu
 * Created: 2002
 */

#ifndef ADDRESS_MANAGER_H
#define ADDRESS_MANAGER_H

#include <wx/wx.h>
#include <wx/txtstrm.h>
#include <wx/wfstream.h>
#include <wx/zstream.h>
#include <wx/grid.h>
#include <wx/colordlg.h>
#include "ColumnField.h"

#if !defined(__WXMSW__)
extern char * addresses_xpm[];
#endif

enum {
	MENU_EDIT_CUT = 1,
	MENU_EDIT_COPY,
	MENU_EDIT_PASTE,
	MENU_TABLE_DOUBLET,
	MENU_TABLE_SORT,
	MENU_TABLE_CONFIG,
	MENU_EXPORT_EMAIL,
	MENU_EXPORT_SMS,
	MENU_EXPORT_FAX,
	MENU_FILE_EXIT
};

/**
 * The file format is based on tags, for forward and backward compatibility.
 * An ADM file starts with wxUint32 ID: ('a' | ('d' << 8) | ('m' << 16)), followed by a
 * wxUint32 version number, followed by the tags. Every tag starts with a
 * wxUint32 tag id, followed by a wxUint32 size of this tag (the size of the
 * tag data, without the tag id and the tag size bytes), followed by the
 * tag data. The file ends with a admTagEnd with tag size 0.
 */
enum {
	admTagEnd = 0,
	admTagGrid = 2
};

/**
 * The AddressManager application class.
 */
class AddressManagerApp: public wxApp
{
public:
	/**
	 * Creates the menu and shows the frame.
	 * \return TRUE.
	 */
    virtual bool OnInit(void);

	/**
	 * Returns 0, because dirty tag handling is handled in the frame and there are only
	 * one frame.
	 * \return 0.
	 */
    virtual int OnExit();
};

WX_DECLARE_OBJARRAY(ColumnField, ColumnFieldArray);

#endif
